Index: orxonox/trunk/src/gui/Makefile.am
===================================================================
--- orxonox/trunk/src/gui/Makefile.am	(revision 3422)
+++ orxonox/trunk/src/gui/Makefile.am	(revision 3423)
@@ -1,5 +1,5 @@
-AM_CXXFLAGS=$(GTK2_CFLAGS) $(MSBITFIELDS)
-#AM_LDFLAGS=$(GTK2_LIBS)
-LIBS=$(GTK2_LIBS)
+AM_CXXFLAGS=$(GTK2_CFLAGS) $(GTHREAD_CFLAGS) $(CURL_CFLAGS) $(MSBITFIELDS)
+#AM_LDFLAGS=$(GTK2_LIBS)   $(GTHREAD_LIBS)
+LIBS=$(GTK2_LIBS) $(GTHREAD_LIBS) $(CURL_LIBS)
 
 bin_PROGRAMS=gui
@@ -11,5 +11,6 @@
 	    orxonox_gui_flags.cc \
 	    orxonox_gui_banner.cc \
-	    orxonox_gui_keys.cc
+	    orxonox_gui_keys.cc \
+	    orxonox_gui_update.cc
 
 noinst_HEADERS=orxonox_gui.h \
@@ -20,5 +21,6 @@
 	    orxonox_gui_flags.h \
 	    orxonox_gui_banner.h \
-	    orxonox_gui_keys.h
+	    orxonox_gui_keys.h \
+	    orxonox_gui_update.h
 
 #  uncomment the following if orxonox requires the mathlibrary
Index: orxonox/trunk/src/gui/orxonox_gui.cc
===================================================================
--- orxonox/trunk/src/gui/orxonox_gui.cc	(revision 3422)
+++ orxonox/trunk/src/gui/orxonox_gui.cc	(revision 3423)
@@ -24,4 +24,6 @@
 */
 
+#include <unistd.h>
+
 #include "orxonox_gui.h"
 #include "orxonox_gui_video.h"
@@ -31,4 +33,5 @@
 #include "orxonox_gui_banner.h"
 #include "orxonox_gui_keys.h"
+#include "orxonox_gui_update.h"
 
   Window* orxonoxGUI;
@@ -39,6 +42,8 @@
   OrxonoxGuiBanner* banner;
   OrxonoxGuiKeys* keys;
+  OrxonoxGuiUpdate* update;
+int verbose = 4;
 
-int main( int argc, char *argv[] )
+int main(int argc, char *argv[])
 {
   OrxonoxGui* orxonoxgui = new OrxonoxGui(argc, argv);
@@ -51,14 +56,9 @@
    \brief Initializes the Gui
 */
-OrxonoxGui::OrxonoxGui (int argc, char *argv[])
+OrxonoxGui::OrxonoxGui(int argc, char *argv[])
 {
-#ifdef HAVE_GTK2
-  initGTK(argc, argv);
-#endif /* HAVE_GTK2 */
-  orxonoxGUI = new Window( "Grafical OrxOnoX loader, "PACKAGE_VERSION);
-#ifdef HAVE_GTK2
-  orxonoxGUI->connectSignal ("destroy", orxonoxGUI->orxonox_gui_quit);
-  orxonoxGUI->connectSignal ("delete_event", orxonoxGUI->orxonox_gui_quit);
-#endif /* HAVE_GTK2 */
+  initGUI(argc, argv);
+
+  orxonoxGUI = new Window( "grafical orxonox loader, "PACKAGE_VERSION);
   
   Box* windowBox = new Box ('h');
@@ -67,50 +67,73 @@
   windowBox->fill (banner->getWidget());
   
-  Box* optionBox = new Box ('v');
+  Box* optionBox = new Box('v');
   
-  Box* avBox = new Box ('h');
+  Box* avBox = new Box('h');
 
-  video = new OrxonoxGuiVideo ();
-  avBox->fill (video->getWidget ());
-  audio = new OrxonoxGuiAudio ();
-  avBox->fill (audio->getWidget ());
+  video = new OrxonoxGuiVideo();
+  avBox->fill(video->getWidget());
+  audio = new OrxonoxGuiAudio();
+  avBox->fill(audio->getWidget());
       
-  optionBox->fill (avBox);
+  optionBox->fill(avBox);
 
-  keys = new OrxonoxGuiKeys ();
-  optionBox->fill (keys->getWidget ());
+  keys = new OrxonoxGuiKeys();
+  optionBox->fill(keys->getWidget());
 
-  exec = new OrxonoxGuiExec (orxonoxGUI);
-  optionBox->fill (exec->getWidget ());
+  exec = new OrxonoxGuiExec();
+  optionBox->fill(exec->getWidget());
 
-  flags = new OrxonoxGuiFlags (orxonoxGUI);
+  flags = new OrxonoxGuiFlags();
+
+  optionBox->fill(flags->getWidget());
+  windowBox->fill(optionBox);
+
+  update = new OrxonoxGuiUpdate();
+  optionBox->fill(update->getWidget());
+  
+  orxonoxGUI->fill(windowBox);
+
+  // Reading Values from File
+  exec->setFilename("~/.orxonox.conf");
+  exec->readFromFile(orxonoxGUI);
+  // Merging changes to the Options from appended flags.
+  for (int optCount = 1; optCount < argc; optCount++)
+    orxonoxGUI->walkThrough(Widget::flagCheck, argv[optCount], 0);
+
+  flags->setTextFromFlags(orxonoxGUI);
+  orxonoxGUI->showall();
+
+  //// Handling special Cases. ///
+
+  // case update //
+#ifdef HAVE_CURL
+  if (static_cast<Option*>(orxonoxGUI->findWidgetByName("auto update", 0))->value == 1)
+    {
+      update->checkForUpdates();
+    }
+#endif /* HAVE_CURL */
+
+  // case start-with-gui.
+  if (!access(exec->getConfigFile(), F_OK) && static_cast<Option*>(orxonoxGUI->findWidgetByName("Always Show this Menu", 0))->value == 0)
+    OrxonoxGuiExec::startOrxonox(NULL, exec);
+  else
+    {
+      mainloopGUI();
+    }
+
+}
 
 
-  optionBox->fill (flags->getWidget ());
-  windowBox->fill (optionBox);
-  
-  orxonoxGUI->fill (windowBox);
-  flags->setTextFromFlags (orxonoxGUI);
-
-  exec->setFilename ("~/.orxonox.conf");
-  exec->readFromFile (orxonoxGUI);
-  //  orxonoxGUI->walkThrough(orxonoxGUI->listOptions);
-
-  orxonoxGUI->showall ();
-
-  
-#ifdef HAVE_GTK2
-  mainloopGTK();
-#else /* HAVE_GTK2 */
-  cout << " Listing all the Orxonox Options: \n";
-  cout << "  #############################\n";
-  orxonoxGUI->walkThrough(orxonoxGUI->listOptions);
-
-  cout << "\nDo you want me to save the the above values now? [Yn] ";
-  char c = getchar();
-  if ((c == 'y' || c == 'Y' || c== 10) && exec->shouldsave())
-    exec->writeToFile (Window::mainWindow);
- 
-#endif /* HAVE_GTK2 */
-
+/**
+   \brief Destructor.
+*/
+OrxonoxGui::~OrxonoxGui(void)
+{
+  delete video;
+  delete audio;
+  delete exec;
+  delete flags;
+  delete banner;
+  delete keys;
+  delete update;
 }
Index: orxonox/trunk/src/gui/orxonox_gui.h
===================================================================
--- orxonox/trunk/src/gui/orxonox_gui.h	(revision 3422)
+++ orxonox/trunk/src/gui/orxonox_gui.h	(revision 3423)
@@ -25,10 +25,8 @@
 {
  public:
-  OrxonoxGui (int argc, char *argv[]);
-  ~OrxonoxGui ();
+  OrxonoxGui(int argc, char *argv[]);
+  ~OrxonoxGui(void);
 
 };
 
-
-
 #endif /* _ORXONOX_GUI_H */
Index: orxonox/trunk/src/gui/orxonox_gui_audio.cc
===================================================================
--- orxonox/trunk/src/gui/orxonox_gui_audio.cc	(revision 3422)
+++ orxonox/trunk/src/gui/orxonox_gui_audio.cc	(revision 3423)
@@ -29,28 +29,36 @@
    \brief Creates an Audio-Frame
 */
-OrxonoxGuiAudio::OrxonoxGuiAudio ()
+OrxonoxGuiAudio::OrxonoxGuiAudio(void)
 {
-  audioFrame = new Frame ("Audio-Options:");
-  audioBox = new Box ('v');
-  audioFrame->setGroupName ("audio");
+  this->audioFrame = new Frame("Audio-Options:");
+  this->audioBox = new Box('v');
+  this->audioFrame->setGroupName("audio");
   
-  enableSound = new CheckButton ("Disable Sound");
-  enableSound->setFlagName ("no-sound", 0);
-  enableSound->saveable = true;
-  audioBox->fill (enableSound);
-  Label* musicVolumeLabel = new Label ("Music Volume");
-  audioBox->fill (musicVolumeLabel);
-  musicVolume = new Slider ("Music Volume", 0, 100);
-  musicVolume->setFlagName ("music-volume", "m", 80);
-  musicVolume->saveable = true;
-  audioBox->fill (musicVolume);
+  this->enableSound = new CheckButton("Disable Sound");
+  this->enableSound->setFlagName ("no-sound", 0);
+  this->enableSound->saveability();
+  this->audioBox->fill(this->enableSound);
+  Label* musicVolumeLabel = new Label("Music Volume");
+  this->audioBox->fill(musicVolumeLabel);
+  this->musicVolume = new Slider("Music Volume", 0, 100);
+  this->musicVolume->setFlagName("music-volume", "m", 80);
+  this->musicVolume->saveability();
+  this->audioBox->fill (this->musicVolume);
   Label* effectsVolumeLabel = new Label ("Effects Volume");
-  audioBox->fill (effectsVolumeLabel);
-  effectsVolume = new Slider ("Effects Volume", 0, 100);
-  effectsVolume->setFlagName ("effects-volume", "e", 80);
-  effectsVolume->saveable = true;
-  audioBox->fill (effectsVolume);
+  this->audioBox->fill (effectsVolumeLabel);
+  this->effectsVolume = new Slider ("Effects Volume", 0, 100);
+  this->effectsVolume->setFlagName ("effects-volume", "e", 80);
+  this->effectsVolume->saveability();
+  this->audioBox->fill (this->effectsVolume);
 
-  audioFrame->fill (audioBox);
+  this->audioFrame->fill (this->audioBox);
+}
+
+/** 
+    \brief Destructs the Audio-Stuff
+*/
+OrxonoxGuiAudio::~OrxonoxGuiAudio(void)
+{
+  // nothing to do here.
 }
 
@@ -59,6 +67,6 @@
    \return Returns the Audio-frame
 */
-Widget* OrxonoxGuiAudio::getWidget ()
+Widget* OrxonoxGuiAudio::getWidget(void)
 {
-  return audioFrame;
+  return this->audioFrame;
 }
Index: orxonox/trunk/src/gui/orxonox_gui_audio.h
===================================================================
--- orxonox/trunk/src/gui/orxonox_gui_audio.h	(revision 3422)
+++ orxonox/trunk/src/gui/orxonox_gui_audio.h	(revision 3423)
@@ -19,8 +19,8 @@
   Slider* effectsVolume;    //!< A Slider for effects volume.
  public:
-  OrxonoxGuiAudio ();
-  ~OrxonoxGuiAudio ();
+  OrxonoxGuiAudio(void);
+  ~OrxonoxGuiAudio(void);
   
-  Widget* getWidget ();
+  Widget* getWidget(void);
 };
 #endif /* _ORXONOX_GUI_AUDIO_H */
Index: orxonox/trunk/src/gui/orxonox_gui_banner.cc
===================================================================
--- orxonox/trunk/src/gui/orxonox_gui_banner.cc	(revision 3422)
+++ orxonox/trunk/src/gui/orxonox_gui_banner.cc	(revision 3423)
@@ -29,35 +29,35 @@
    \brief Creates a new BannerEventBox and its content.
 */
-OrxonoxGuiBanner::OrxonoxGuiBanner ()
+OrxonoxGuiBanner::OrxonoxGuiBanner(void)
 {
   // Banner Itself //
-  bannerEventBox = new EventBox ("BannerEventBox");
-  bannerImage = new Image ("banner.xpm");
-  bannerEventBox->fill(bannerImage);
+  this->bannerEventBox = new EventBox("BannerEventBox");
+  this->bannerImage = new Image("banner.xpm");
+  this->bannerEventBox->fill(this->bannerImage);
 
   // Banner Window //
-  logoWindow = new Window("Logo");
+  this->logoWindow = new Window("Logo");
 
 #ifdef HAVE_GTK2
-  bannerEventBox->connectSignal ("button_press_event", logoWindow, Window::windowOpen);
+  this->bannerEventBox->connectSignal("button_press_event", this->logoWindow, Window::windowOpen);
 
-  logoWindow->connectSignal("destroy", logoWindow, Window::windowClose);
-  logoWindow->connectSignal("delete_event", logoWindow, Window::windowClose);
+  this->logoWindow->connectSignal("destroy", this->logoWindow, Window::windowClose);
+  this->logoWindow->connectSignal("delete_event", this->logoWindow, Window::windowClose);
 #endif /* HAVE_GTK2 */
-  logoEventBox = new EventBox();
-  logoBox = new Box('v');
-  logoLabel = new Label("OrxOnoX, Version: " PACKAGE_VERSION);
-  logoImage = new Image("banner.xpm");
-  logoEventBox->fill(logoImage);
+  this->logoEventBox = new EventBox();
+  this->logoBox = new Box('v');
+  this->logoLabel = new Label("OrxOnoX, Version: " PACKAGE_VERSION);
+  this->logoImage = new Image("banner.xpm");
+  this->logoEventBox->fill(this->logoImage);
   
-  logoBox->fill(logoLabel);
-  logoBox->fill(logoEventBox);
+  this->logoBox->fill(this->logoLabel);
+  this->logoBox->fill(this->logoEventBox);
 #ifdef HAVE_GTK2
-  logoEventBox->connectSignal("button_press_event",logoWindow, Window::windowClose);
+  this->logoEventBox->connectSignal("button_press_event", this->logoWindow, Window::windowClose);
 #endif /* HAVE_GTK2 */
 
-  logoWindow->fill (logoBox);
+  this->logoWindow->fill(this->logoBox);
   
-  Window::addWindow (logoWindow);
+  Window::addWindow(this->logoWindow);
 }
 
@@ -65,6 +65,7 @@
    \brief Destructs it.
 */
-OrxonoxGuiBanner::~OrxonoxGuiBanner ()
+OrxonoxGuiBanner::~OrxonoxGuiBanner(void)
 {
+  // nothing to do here
 }
 
@@ -73,7 +74,7 @@
    \return The EventBox, that holds the Banner.
 */
-Widget* OrxonoxGuiBanner::getWidget ()
+Widget* OrxonoxGuiBanner::getWidget(void)
 {
-  return bannerEventBox;
+  return this->bannerEventBox;
 }
 
Index: orxonox/trunk/src/gui/orxonox_gui_banner.h
===================================================================
--- orxonox/trunk/src/gui/orxonox_gui_banner.h	(revision 3422)
+++ orxonox/trunk/src/gui/orxonox_gui_banner.h	(revision 3423)
@@ -29,8 +29,8 @@
 
  public:
-  OrxonoxGuiBanner ();
-  ~OrxonoxGuiBanner ();
+  OrxonoxGuiBanner(void);
+  ~OrxonoxGuiBanner(void);
 
-  Widget* getWidget ();
+  Widget* getWidget(void);
 
 };
Index: orxonox/trunk/src/gui/orxonox_gui_exec.cc
===================================================================
--- orxonox/trunk/src/gui/orxonox_gui_exec.cc	(revision 3422)
+++ orxonox/trunk/src/gui/orxonox_gui_exec.cc	(revision 3423)
@@ -28,40 +28,52 @@
 #include <string>
 
+HashTable* orxonoxFlagHash;
+
 /** 
     \brief Creates the Exec-Frame
-    \param orxonoxGUI ExecFrame needs to know where to get the Options from
-*/
-OrxonoxGuiExec::OrxonoxGuiExec (Window* orxonoxGUI)
-{
-  configFile = (char*)malloc (512*sizeof (char));
-
-  execFrame = new Frame ("Execute-Tags:");
-  execBox = new Box ('v');
-  execFrame->setGroupName ("misc");
+*/
+OrxonoxGuiExec::OrxonoxGuiExec(void)
+{
+  configFile =(char*)malloc(512*sizeof(char));
+
+  this->execFrame = new Frame("Execute-Tags:");
+  this->execBox = new Box('v');
+  this->execFrame->setGroupName("misc");
   
-  start = new Button ("Start");
+  this->start = new Button("Start");
 #ifdef HAVE_GTK2
-  start->connectSignal ("clicked", startOrxonox);
+  this->start->connectSignal("clicked", this, startOrxonox);
 #endif /* HAVE_GTK2 */
-  execBox->fill (start);
-  saveSettings = new CheckButton ("Save Settings");
-  saveSettings->value = 1;
-  saveSettings->saveable = true;
-  execBox->fill (saveSettings);
-  verboseMode = new Menu ("verbose mode", "no output", "verbose", "debug", "lastItem");
-  verboseMode->setFlagName ("verbose", "v", 0);
-  verboseMode->saveable = true;
-  execBox->fill (verboseMode);
-  alwaysShow = new CheckButton ("Always Show this Menu");
-  alwaysShow->setFlagName ("gui", "g", 0);
-  alwaysShow->saveable = true;
-  execBox->fill (alwaysShow);
-  quit = new Button ("Quit");
+  this->execBox->fill(start);
+  this->saveSettings = new CheckButton("Save Settings");
+  this->saveSettings->value = 1;
+  this->saveSettings->saveability();
+  this->execBox->fill(this->saveSettings);
+  this->verboseMode = new Menu("verbose mode", "no output", "error", "warning", "info", "lastItem");
+  this->verboseMode->setFlagName("verbose", "v", 0);
+  this->verboseMode->saveability();
+  this->execBox->fill(this->verboseMode);
+  this->alwaysShow = new CheckButton("Always Show this Menu");
+  this->alwaysShow->setFlagName("gui", "g", 0);
+  this->alwaysShow->saveability();
+  this->execBox->fill(this->alwaysShow);
+  this->quit = new Button("Quit");
 #ifdef HAVE_GTK2
-  quit->connectSignal ("clicked", orxonoxGUI->orxonox_gui_quit);
+  this->quit->connectSignal("clicked", this, OrxonoxGuiExec::quitOrxonox);
+  //  Window::mainWindow->connectSignal("remove", this, OrxonoxGuiExec::quitOrxonox);
+  Window::mainWindow->connectSignal("destroy", this, OrxonoxGuiExec::quitOrxonox);
 #endif /* HAVE_GTK2 */
-  execBox->fill (quit);
-
-  execFrame->fill (execBox);
+  this->execBox->fill(this->quit);
+
+  this->execFrame->fill(this->execBox);
+}
+
+/**
+   \brief Destructs the Execution-stuff
+*/
+OrxonoxGuiExec::~OrxonoxGuiExec(void)
+{
+  if(this->configFile)
+    delete []this->configFile;
 }
 
@@ -70,5 +82,5 @@
    \return Returns the Exec-frame
 */
-Widget* OrxonoxGuiExec::getWidget ()
+Widget* OrxonoxGuiExec::getWidget(void)
 {
   return execFrame;
@@ -78,23 +90,34 @@
 
 /**
-   \brief Sets the location of the configuration File.\n
-   * The name will be parsed from ~/ to /home/[username] on unix and c:/Documents and Settings/username/Settings/ on Windows
+   \brief Sets the location of the configuration File.
    \param filename the location of the configFile
-*/
-void OrxonoxGuiExec::setFilename (char* filename)
-{
-  char* buffer = (char*) malloc (512*sizeof(buffer));
-  sprintf (buffer, "%s", filename);
-  if (!strncmp (buffer, "~/", 2))
+
+   \todo: memory allocation could be better.
+
+   The name will be parsed from ~/ to /home/[username] on unix and c:/Documents and Settings/username/Settings/ on Windows
+*/
+void OrxonoxGuiExec::setFilename(char* filename)
+{
+  char* buffer = (char*)malloc(2048*sizeof(char));
+  sprintf(buffer, "%s", filename);
+  if(!strncmp(buffer, "~/", 2))
   {
 #ifdef __WIN32__
-    sprintf (configFile, "%s/%s", getenv ("USERPROFILE"), buffer+2);
+    sprintf(configFile, "%s/%s", getenv("USERPROFILE"), buffer+2);
 #else
-    sprintf (configFile, "%s/%s", getenv ("HOME"), buffer+2);
+    sprintf(configFile, "%s/%s", getenv("HOME"), buffer+2);
 #endif
   }
-  else if (buffer)
-    sprintf(configFile, "%s", buffer);
-  delete buffer;
+  else if(buffer)
+    strcpy(this->configFile, buffer);
+  free (buffer);
+}
+
+/**
+   \returns The name of the Configuration-File
+*/
+char* OrxonoxGuiExec::getConfigFile(void)
+{
+  return this->configFile;
 }
 
@@ -103,7 +126,7 @@
    \return 1 if it should 0 if not/
 */
-int OrxonoxGuiExec::shouldsave ()
-{
-  return (static_cast<Option*>(saveSettings)->value);
+int OrxonoxGuiExec::shouldsave()
+{
+  return(static_cast<Option*>(this->saveSettings)->value);
 }
 
@@ -112,12 +135,12 @@
     \param widget from which Widget on should be saved.
 
-    this Function only opens and closes the file, in between OrxonoxGuiExec::writeFileText (Widget* widget) will execute the real writing process.
-*/
-void OrxonoxGuiExec::writeToFile (Widget* widget)
-{
-  CONFIG_FILE = fopen (configFile, "w");
-  if (CONFIG_FILE)
-    writeFileText (widget, 0);
-  fclose (CONFIG_FILE);
+    this Function only opens and closes the file, in between OrxonoxGuiExec::writeFileText(Widget* widget) will execute the real writing process.
+*/
+void OrxonoxGuiExec::writeToFile(Widget* widget)
+{
+  this->CONFIG_FILE = fopen(configFile, "w");
+  if(this->CONFIG_FILE)
+    this->writeFileText(widget, 0);
+  fclose(this->CONFIG_FILE);
 }
 
@@ -127,52 +150,52 @@
    \param depth initially "0", and grows higher, while new Groups are bundeled.
 */
-void OrxonoxGuiExec::writeFileText (Widget* widget, int depth)
+void OrxonoxGuiExec::writeFileText(Widget* widget, int depth)
 {
   int counter = 0;
-  while (counter < depth && ((widget->isOption>0
-			      && (static_cast<Option*>(widget)->saveable) )
-			     || (widget->isOption<0
-				 && static_cast<Packer*>(widget)->getGroupName())))
-    {
-      fprintf (CONFIG_FILE, "  ", depth);
+  while(counter < depth &&((widget->isOption>0
+			      &&(static_cast<Option*>(widget)->isSaveable()))
+			     ||(widget->isOption<0
+				&& static_cast<Packer*>(widget)->getGroupName())))
+    {
+      fprintf(this->CONFIG_FILE, "  ", depth);
       counter++;
     }
   
   // check if it is a Packer, and if it is, check if it has a name and if there is something in it.
-  if (widget->isOption <0)
-    {
-      if (static_cast<Packer*>(widget)->getGroupName())
-	{
-	  fprintf (CONFIG_FILE, "[%s]\n", static_cast<Packer*>(widget)->getGroupName());
-	  writeFileText (static_cast<Packer*>(widget)->down, depth+1);
+  if(widget->isOption <0)
+    {
+      if(static_cast<Packer*>(widget)->getGroupName())
+	{
+	  fprintf(CONFIG_FILE, "[%s]\n", static_cast<Packer*>(widget)->getGroupName());
+	  this->writeFileText(static_cast<Packer*>(widget)->down, depth+1);
 	  fprintf(CONFIG_FILE, "\n");
 	}
       else
 	{
-	  writeFileText (static_cast<Packer*>(widget)->down, depth);
+	  this->writeFileText(static_cast<Packer*>(widget)->down, depth);
 	}
     } 
-  //  if (widget->isOption == 0)
-  //    printf ("%s\n",widget->label);
-  if (widget->isOption >= 1)
-    if  (static_cast<Option*>(widget)->saveable)
+  //  if(widget->isOption == 0)
+  //    printf("%s\n",widget->title);
+  if(widget->isOption >= 1)
+    if (static_cast<Option*>(widget)->isSaveable())
       {
 	char Buffer[256];
 	char* space2under;
-	strcpy (Buffer, static_cast<Option*>(widget)->label);
-	if (strchr (Buffer, '_'))
+	strcpy(Buffer, static_cast<Option*>(widget)->title);
+	if(strchr(Buffer, '_'))
 	  cout << "Warning Optionname" << Buffer << " is not Valid for Saving, because it includes an underscore" << endl;
-	while (space2under = strchr(Buffer, ' '))
+	while(space2under = strchr(Buffer, ' '))
 	  {
 	    space2under[0] = '_';
 	  }
-	if (widget->isOption <=3)
-	  fprintf (CONFIG_FILE, "%s = %d\n", Buffer, static_cast<Option*>(widget)->value);
-	else if (widget->isOption == 5)
-	  fprintf (CONFIG_FILE, "%s = %s\n", Buffer, static_cast<OptionLabel*>(widget)->cValue);
+	if(widget->isOption <=3)
+	  fprintf(CONFIG_FILE, "%s = %d\n", Buffer, static_cast<Option*>(widget)->value);
+	else if(widget->isOption == 5)
+	  fprintf(CONFIG_FILE, "%s = %s\n", Buffer, static_cast<OptionLabel*>(widget)->cValue);
       }
 
-  if (widget->next != NULL)
-    writeFileText (widget->next, depth);
+  if(widget->next != NULL)
+    this->writeFileText(widget->next, depth);
 }
 
@@ -181,8 +204,9 @@
    \param widget from which Widget on should be saved.
 */
-void OrxonoxGuiExec::readFromFile (Widget* widget)
-{
-  CONFIG_FILE = fopen (configFile, "r");
-  if (CONFIG_FILE)
+void OrxonoxGuiExec::readFromFile(Widget* widget)
+{
+  this->CONFIG_FILE = fopen(configFile, "r");
+  VarInfo varInfo;
+  if(this->CONFIG_FILE)
     {
       Widget* groupWidget = widget;
@@ -190,60 +214,57 @@
       char Variable[256]= "";
       char* Value;
-      while (fscanf (CONFIG_FILE, "%s", Buffer) != EOF)
+      while(fscanf(this->CONFIG_FILE, "%s", Buffer) != EOF)
 	{
 	  // group-search //
-	  if (!strncmp (Buffer, "[", 1))
+	  if(!strncmp(Buffer, "[", 1))
 	    {
-	      if ((groupWidget = locateGroup (widget, Buffer, 1))==NULL)
+	      if((groupWidget = locateGroup(widget, Buffer, 1))==NULL)
 		{
 		  cout << "!!There is no group called " << Buffer << " in this GUI.\n First best Widget will get the Infos assigned.\n Config-File will be updated in next Save\n";
 		  groupWidget = widget;
 		}
+	      else
+		PRINT(3)("Group %s located.\n", static_cast<Packer*>(groupWidget)->groupName);
 	    }
 	  // option-setting //
-	  if (!strcmp (Buffer, "="))
+	  if(!strcmp(Buffer, "="))
 	    {
 	      char* under2space;
-	      while (under2space = strchr(Variable, '_'))
+	      while(under2space = strchr(Variable, '_'))
 		{
-		  sprintf (under2space, " %s", under2space+1);
+		  sprintf(under2space, " %s", under2space+1);
 		}
 	      
-	      fscanf (CONFIG_FILE, "%s", Buffer);
-	      Value = Buffer;
-	      readFileText (groupWidget, Variable, Value, 0);
-	      sprintf (Variable, "");
+	      fscanf(this->CONFIG_FILE, "%s", Buffer);
+	      varInfo.variableName = Variable;
+	      varInfo.variableValue = Buffer;
+	      groupWidget->walkThrough(this->readFileText, &varInfo, 0);
+	      sprintf(Variable, "");
 	    }
-	  sprintf (Variable, "%s", Buffer);
-	}
-      widget->walkThrough(widget->setOptions);
-    }
-}
+	  sprintf(Variable, "%s", Buffer);
+	}
+      widget->walkThrough(widget->setOptions, 0);
+    }
+}
+
 /**
    \brief Maps Confugurations to the Options.
    \param widget which widget downwards
-   \param variableName the name of the Variable that should be set up.
-   \param variableValue the Value of the Variable that should be set up
-   \param depth the depth of the local Widget
-*/
-void OrxonoxGuiExec::readFileText (Widget* widget, char* variableName, char* variableValue, int depth)
-{
-  if (widget->isOption >= 1 && widget->isOption <= 3)
-    {
-      if (!strcmp (static_cast<Option*>(widget)->label, variableName))
-	static_cast<Option*>(widget)->value = atoi(variableValue);
-    }
-  else if (widget->isOption == 5)
-    {
-       if (!strcmp (static_cast<Option*>(widget)->label, variableName))
-	static_cast<OptionLabel*>(widget)->setValue(variableValue);
-    }
-  if (widget->isOption < 0)
-    {
-      readFileText (static_cast<Packer*>(widget)->down, variableName, variableValue, depth+1);
-    } 
-
-  if (widget->next != NULL && depth !=0)
-    readFileText (widget->next, variableName, variableValue, depth);
+   \param varInfo Information about the Variable to read
+*/
+void OrxonoxGuiExec::readFileText(Widget* widget, void* varInfo)
+{
+  VarInfo* info =(VarInfo*)varInfo;
+  if(widget->title && !strcmp(widget->title, info->variableName))
+    {
+      PRINT(3)("Located Option %s.\n", widget->title);
+      if(widget->isOption >= 1 && widget->isOption <= 3)
+	{
+	  static_cast<Option*>(widget)->value = atoi(info->variableValue);
+	  static_cast<Option*>(widget)->redraw(); //!< \todo change this to setValue.
+	}
+      else if(widget->isOption == 5)
+	static_cast<OptionLabel*>(widget)->setValue(info->variableValue);
+    }
 }
 
@@ -254,4 +275,6 @@
    \param depth The Depth of the search seen from the first widget we searched from.
    \returns The Widget that holds the Group, or the NULL if the Group wasn't found.
+
+   \todo do this in gui-gtk.
 */
 Widget* OrxonoxGuiExec::locateGroup(Widget* widget, char* groupName, int depth)
@@ -260,5 +283,5 @@
 
   // removes the trailing and ending [ ].
-  if (!strncmp (groupName, "[", 1))
+  if(!strncmp(groupName, "[", 1))
     {
       groupName = groupName+1;
@@ -266,7 +289,7 @@
     }
 
-  if (widget->isOption < 0)
-    {
-      if (static_cast<Packer*>(widget)->getGroupName() && !strcmp(groupName, static_cast<Packer*>(widget)->getGroupName()))
+  if(widget->isOption < 0)
+    {
+      if(static_cast<Packer*>(widget)->getGroupName() && !strcmp(groupName, static_cast<Packer*>(widget)->getGroupName()))
 	{
 	  return widget;
@@ -274,12 +297,12 @@
       else
 	{
-	  if ((tmp = locateGroup (static_cast<Packer*>(widget)->down, groupName, depth+1)) != NULL)
+	  if((tmp = locateGroup(static_cast<Packer*>(widget)->down, groupName, depth+1)) != NULL)
 	    return tmp;
 	}
     } 
   
-  if (widget->next != NULL && depth != 0)
-    {
-      if ((tmp = locateGroup (widget->next, groupName, depth)) != NULL)
+  if(widget->next != NULL && depth != 0)
+    {
+      if((tmp = locateGroup(widget->next, groupName, depth)) != NULL)
 	return tmp;
     }
@@ -289,12 +312,63 @@
 #ifdef HAVE_GTK2
 /**
-   \brief Starts ORXONOX. (not really implemented yet, but the function is there.\n
-   This is a Signal and can be executed through Widget::signal_connect
+   \brief Starts ORXONOX.(not really implemented yet, but the function is there.\n
    \param widget the widget that executed the start command
    \param data additional data
-*/
-gint startOrxonox (GtkWidget *widget, Widget* data)
-{
+
+   This is a Signal and can be executed through Widget::signal_connect
+*/
+int OrxonoxGuiExec::startOrxonox(GtkWidget* widget, void* data)
+{
+  OrxonoxGuiExec* exec =(OrxonoxGuiExec*)data;
+  if(exec->shouldsave())
+    exec->writeToFile(Window::mainWindow);
   cout << "Starting Orxonox" <<endl;
-}
+  gtk_main_quit();
+  system("cd ..;./orxonox"); //!< \todo fix this. should execute orxonox for real(coded not over the shell)
+}
+
+/**
+   \brief Starts ORXONOX.(not really implemented yet, but the function is there.\n
+   \param widget the widget that executed the start command
+   \param data additional data
+
+   This is a Signal and can be executed through Widget::signal_connect
+*/
+int OrxonoxGuiExec::quitOrxonox(GtkWidget* widget, void* data)
+{
+  OrxonoxGuiExec* exec =(OrxonoxGuiExec*)data;
+  PRINT(3)( "Quitting Orxonox %p\n", exec);
+  if(exec->shouldsave())
+    exec->writeToFile(Window::mainWindow);
+  gtk_main_quit();
+}
+#else /* HAVE_GTK2 */
+/**
+   \brief Starts ORXONOX.(not really implemented yet, but the function is there.\n
+   \param widget the widget that executed the start command
+   \param data additional data
+*/
+int OrxonoxGuiExec::startOrxonox(void* widget, void* data)
+{
+  OrxonoxGuiExec* exec =(OrxonoxGuiExec*)data;
+  PRINT(3)("Starting Orxonox\n");
+  if(exec->shouldsave())
+    exec->writeToFile(Window::mainWindow);
+  system("cd ..;./orxonox"); //!< \todo fix this. should execute orxonox for real(coded not over the shell)
+}
+/**
+   \brief Quits ORXONOX.
+   \param widget the widget that executed the Quit command
+   \param data additional data
+
+   This is a Signal and can be executed through Widget::signal_connect
+*/
+int OrxonoxGuiExec::quitOrxonox(void* widget, void* data)
+{
+  OrxonoxGuiExec* exec =(OrxonoxGuiExec*)data;
+  PRINT(3)("Quiting Orxonox");
+  if(exec->shouldsave())
+    exec->writeToFile(Window::mainWindow);
+}
+
 #endif /* HAVE_GTK2 */
Index: orxonox/trunk/src/gui/orxonox_gui_exec.h
===================================================================
--- orxonox/trunk/src/gui/orxonox_gui_exec.h	(revision 3422)
+++ orxonox/trunk/src/gui/orxonox_gui_exec.h	(revision 3423)
@@ -24,22 +24,44 @@
   char* configFile;            //!< The name of the .orxonox.conf(ig)-file.
   FILE* CONFIG_FILE;           //!< Filehandler for reading and writing.
+  
+  //! A struct that holds informations about variables.
+  struct VarInfo
+  {
+    char* variableName;        //!< The Name of this variable;
+    char* variableValue;       //!< The Value this variable gets.
+  };
 
  public:
-  OrxonoxGuiExec (Window* orxonoxGUI);
-  ~OrxonoxGuiExec ();
+  OrxonoxGuiExec(void);
+  ~OrxonoxGuiExec(void);
   
-  Widget* getWidget ();
+  Widget* getWidget(void);
   
-  void setFilename (char* filename);
-  int shouldsave ();
-  void writeToFile (Widget* widget);
-  void writeFileText (Widget* widget, int depth);
-  void readFromFile (Widget* widget);
-  void readFileText (Widget* widget, char* variableName, char* variableValue, int depth);
+  void setFilename(char* filename);
+  char* getConfigFile(void);
+  int shouldsave(void);
+  void writeToFile(Widget* widget);
+  void writeFileText(Widget* widget, int depth);
+  void readFromFile(Widget* widget);
+  static void readFileText(Widget* widget, void* varInfo);
   Widget* locateGroup(Widget* widget, char* groupName, int depth);
 
+#ifdef HAVE_GTK2
+  static int startOrxonox(GtkWidget *widget, void* data);
+  static int quitOrxonox(GtkWidget *widget, void* data);
+#else /* HAVE_GTK2 */
+  static int startOrxonox(void* widget, void* data);
+  static int quitOrxonox(void* widget, void* data);
+#endif /* HAVE_GTK2 */
 };
-#ifdef HAVE_GTK2
-  gint startOrxonox (GtkWidget *widget, Widget* data);
-#endif /* HAVE_GTK2 */
+
+
+struct HashTable
+{
+  char* name;
+  char* value;
+  HashTable* next;
+};
+
+
 #endif /* _ORXONOX_GUI_EXEC_H */
